/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _enargv.c,v 1.6 1994/07/27 13:47:59 mura Exp $
 */

/* System headers */
#include <stdlib.h>
#include <limits.h>
#include <sys/dos.h>
#include <sys/xstart.h>
#include <sys/xglob.h>

/* Functions */
int _enargv (const struct _psp *proc, int argc, char **argv, const char *com)
{
    int i, n;
    static char program_name[PATH_MAX + 1];
    char *s, *d = program_name;

    /* HUPAIR ɂN? */
    if (_hupair) {

	/* argv[0] 쐬 */
	s = _comline;
	while (*s++) ;
	while ((*d++ = *s++) != '\0') ;

    }

    /* ʏ̋N */
    else {

	/* argv[0] 쐬 */
	for (s = (char *)&proc->exe_path; (*d++ = *s++); /**/ ) ;
	d -= 1;
	for (s = (char *)&proc->exe_name; (*d++ = *s++); /**/ ) ;
	d -= 2;

	/* program_name ̍Ōオ . Ȃ炻菜 */
	if (*d == '.')
	    *d = '\0';

    }

    /* pXf~^ '/' ɓꂵāAARGV[0] ɋL^ */
    *argv++ = _toslash (program_name);
    n = 1;

    /* ARGV z𐶐 */
    for (i = 0; i < argc; i++) {

	/* IvVw肩 */
	if (com[0] == '-' && com[1] == '+' && com[2] == '-') {
	    if (com[3] == 'h' && com[4] == ':') {
		_heapsize = atoi (com + 5);
		goto skipit;
	    }
	    else if (com[3] == 's' && com[4] == ':') {
		_stacksize = atoi (com + 5);
		goto skipit;
	    }
	    else if (com[3] == 'p') {
		_superman |= _SUPER_GO;
		goto skipit;
	    }
	    else if (com[3] == 'f') {
		_superman |= _SUPER_FLOAT;
		goto skipit;
	    }
	    else if (com[3] == 'g') {
		_cplusplus = 1;
		goto skipit;
	    }
	}

	/* ARGV ݒ */
	*argv++ = (char *) com;
	n++;

    skipit:

	/* ̈̐擪܂ŃXLbv */
	while (*com++);

    }

    /* Ō 0 őł~߂ */
    *argv = (char *)0;

    /* ̐Ԃ */
    return n;
}
